unit adventure;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls,mmsystem,jpeg,  JclExprEval,
  Vcl.AppEvnts, GIFImg, Vcl.Imaging.pngimage;

type
  TForm2 = class(TForm)
    GroupBox1: TGroupBox;
    Select1: TButton;
    Select2: TButton;
    Select3: TButton;
    Select4: TButton;
    msg: TLabel;
    Image: TImage;
    Timer1: TTimer;
    OpenDialog: TOpenDialog;
    ApplicationEvents1: TApplicationEvents;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure Select1Click(Sender: TObject);
    procedure Select2Click(Sender: TObject);
    procedure Select3Click(Sender: TObject);
    procedure Select4Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ApplicationEvents1Message(var Msg: tagMSG; var Handled: Boolean);
  private
    { Private 錾 }
  public
    procedure setScene(script:string);
    procedure show(ID:integer);
    function getID(ID:integer):integer;
    procedure setText(msg:tlabel; text:string);
    function eval(exp:string):boolean;
    function  rep(s: string): string;
    function logic(expr:string):boolean;


  end;

type scene=record
  ID:integer;
  Msg:String;
  Image:string;
  Music:string;
  next:integer;
  eval:string;
  select1Msg:string;
  select1cond:string;
  select1to:integer;
  select2Msg:string;
  select2cond:string;
  select2to:integer;
  select3Msg:string;
  select3cond:string;
  select3to:integer;
  select4Msg:string;
  select4cond:string;
  select4to:integer;
end;
  pScene=^scene;

  type flg=record
  name:string;
  value:extended;
  ptr:pextended;
end;
  pflg=^flg;

var
  Form2: TForm2;
  senario:Tstringlist;
  scenes:Tlist;
  flgs:Tlist;

  hasGraphic:boolean;
  current:integer;
  currentPOS:integer;
  msgstring:string;
  FEvaluator: TEasyEvaluator;
  F_hHandle:hwnd;

implementation

{$R *.dfm}

procedure TForm2.ApplicationEvents1Message(var Msg: tagMSG;
  var Handled: Boolean);
begin
  if (Msg.message = MM_MCINOTIFY) then
  begin
  if msg.wParam=MCI_NOTIFY_SUCCESSFUL
  then
  begin
    mciSendString('seek audio to start',nil,0,F_hHandle);
    mciSendString(pchar('play audio notify'),nil,0,F_hHandle);
  end;

  end;
end;

function TForm2.eval(exp: string): boolean;
var
key,value:string;
var
i:integer;
flag,isset:boolean;
ptr:pextended;
pflgs:pflg;
sple:extended;
begin
  isset:=false;
  exp:=rep(exp);
  if pos(':=',exp)<>0 then
  begin
    key:=(copy(exp,0,pos(':=',exp)-1));
    value:=copy(exp,pos(':=',exp)+2);
    flag:=true;
    i:=0;
    if flgs.Count<>0 then
    while(flag) do
    begin
      if (pflg(flgs[i])^.name=key) then
      begin
        flag:=false;
        ptr:= pflg(flgs[i])^.ptr;
        result:=TryStrToFloat(value, ptr^);
        if result=false then showmessage('Zbgł܂ł:'+key+'='+value);

        isset:=true;
    //     showmessage(key);
    //     showmessage(key+'='+FloatToStr((FEvaluator as tevaluator).Evaluate(key)));
    //  showmessage(floattostr(pflg(flgs[i])^.value));
      end;

      inc(i);
      if (i>flgs.Count-1) then flag:=false;

    end;
    if isset=false then
    begin
     new(pflgs);
     pflgs^.name:=key;
     pflgs^.value:=strtoint(value);
     pflgs^.ptr:=nil;
     flgs.Add(pflgs);
     pflg(flgs[flgs.Count-1])^.ptr:=@pflg(flgs[flgs.Count-1])^.value;
     FEvaluator.AddVar(key,pflg(flgs[flgs.Count-1])^.value);

 //  showmessage(key+'='+FloatToStr((FEvaluator as tevaluator).Evaluate(key)));

    end;
  end;
end;

function TForm2.rep(s: string): string;
begin
    s:=stringReplace(s,'==','[eq]',[rfReplaceAll,rfIgnoreCase]);
    s:=stringReplace(s,'!=','<>',[rfReplaceAll,rfIgnoreCase]);
    s:=stringReplace(s,'=',':=',[rfReplaceAll,rfIgnoreCase]);
    s:=stringReplace(s,'[eq]','=',[rfReplaceAll,rfIgnoreCase]);
    s:=stringReplace(s,'true','1',[rfReplaceAll,rfIgnoreCase]);
    s:=stringReplace(s,'false','0',[rfReplaceAll,rfIgnoreCase]);
    s:=stringReplace(s,'&&','and',[rfReplaceAll,rfIgnoreCase]);
    s:=stringReplace(s,'||','or',[rfReplaceAll,rfIgnoreCase]);
    s:=stringReplace(s,';','',[rfReplaceAll,rfIgnoreCase]);
    s:=stringReplace(s,'var ','',[rfReplaceAll,rfIgnoreCase]);
    result:=s;

end;

procedure TForm2.FormClick(Sender: TObject);
begin
if (pscene(scenes[current])^.next)<>0 then
begin
show(pscene(scenes[current])^.next);
end;
end;

procedure TForm2.FormCreate(Sender: TObject);
var i:integer;
begin
  F_hHandle:=application.Handle;
  FEvaluator := TEvaluator.Create;
  currentPOS:=-1;
  scenes:=tlist.Create;
  flgs:=tlist.Create;
  senario:=tstringlist.Create;
  if fileexists(getcurrentdir+'\'+'senario.js') then senario.LoadFromFile(getcurrentdir+'\'+'senario.js')
  else
  begin
    if opendialog.Execute then
    begin
    senario.LoadFromFile(opendialog.FileName);
    setcurrentdir(extractfilepath(opendialog.filename));
    end else application.Terminate;
  end;
  for I :=0 to senario.Count-1 do
    begin
      setScene(senario[i]);
    end;

   show(0);
end;

procedure TForm2.FormDestroy(Sender: TObject);
var i:integer;
begin
Fevaluator.Free;
senario.Free;
   for i:= 0 to scenes.count-1 do dispose(Pscene(scenes[i]));
   scenes.free;
   for i:= 0 to flgs.count-1 do dispose(Pflg(flgs[i]));
   flgs.free;

  mciSendString(pchar('stop audio'),nil,0,F_hHandle);
  mciSendString(pchar('close audio'),nil,0,F_hHandle);
end;

procedure TForm2.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=VK_SPACE then form2.Click;

if key=VK_ESCAPE then
begin
  application.Terminate;
  key:=0;
end;
if (ssalt in shift) and (key=VK_return) then
begin
  if form2.BorderStyle=bsNone then
  begin
    form2.BorderStyle:=bsDialog;
    form2.Left:=100;
    form2.Top:=100;
    form2.width:=740;
    form2.Height:=450;
    groupbox1.Left:=527;
    groupbox1.top:=16;
    groupbox1.width:=193;
    groupbox1.height:=209;
    image.Left:=0;
    image.Top:=0;
    image.Width:=521;
    image.Height:=233;
    msg.top:=231;
    msg.Left:=0;
    msg.Width:=598;
    msg.Font.Height:=25;
    select1.Font.Height:=15;
    select1.Width:=187;
    select1.height:=25;
    select2.Font.Height:=15;
    select2.Width:=187;
    select2.height:=25;
    select3.Font.Height:=15;
    select3.Width:=187;
    select3.height:=25;
    select4.Font.Height:=15;
    select4.Width:=187;
    select4.height:=25;
    select1.Top:=40;
    select2.Top:=80;
    select3.Top:=120;
    select4.Top:=160;
    form2.Position:=poDesktopCenter;

    form2.FormStyle:=fsNormal;
 end else
 begin
    form2.BorderStyle:=bsNone;
    form2.Left:=0;
    form2.Top:=0;
    form2.width:=getdevicecaps(canvas.Handle,HORZRES);
    form2.Height:=getdevicecaps(canvas.Handle,VERTRES);
    groupbox1.Left:=round(getdevicecaps(canvas.Handle,HORZRES)*0.7);
    groupbox1.top:=1;
    groupbox1.width:=round(getdevicecaps(canvas.Handle,HORZRES)*0.3);
    groupbox1.height:=round(getdevicecaps(canvas.Handle,VERTRES)*0.6);
    image.Left:=0;
    image.Top:=0;
    image.Width:=round(getdevicecaps(canvas.Handle,HORZRES)*0.7);
    image.Height:=round(getdevicecaps(canvas.Handle,VERTRES)*0.6);
    msg.top:=round(getdevicecaps(canvas.Handle,VERTRES)*0.61);
    msg.Left:=0;
    msg.Width:=round(getdevicecaps(canvas.Handle,VERTRES));
    msg.Font.Height:=42;
    select1.Font.Height:=25;
    select1.Width:=round(getdevicecaps(canvas.Handle,HORZRES)*0.28);
    select1.height:=50;
    select2.Font.Height:=25;
    select2.Width:=round(getdevicecaps(canvas.Handle,HORZRES)*0.28);
    select2.height:=50;
    select3.Font.Height:=25;
    select3.Width:=round(getdevicecaps(canvas.Handle,HORZRES)*0.28);
    select3.height:=50;
    select4.Font.Height:=25;
    select4.Width:=round(getdevicecaps(canvas.Handle,HORZRES)*0.28);
    select4.height:=50  ;
    select1.Top:=40;
    select2.Top:=120;
    select3.Top:=200;
    select4.Top:=280;
    form2.Position:=poDefault;

    form2.FormStyle:=fsStayOnTop;

 end;
end;
end;

procedure TForm2.setScene(script: string);
var
 datas:tstringlist;
 str:string;
 i:integer;
 ptr:pscene;
begin
if pos('//',script)<>0 then
begin
  script:=copy(script,0,pos('//',script)-1);
end;
 if script='' then exit;

 str:=script;
 if Copy(str,0,9)='setScene(' then
  begin
    i:=0;
    str:=copy(str,10,length(str)-9);
    if pos(');',str)<>0 then str:=copy(str,0, pos(');',str)-1);
    datas:=tstringlist.Create;
    datas.CommaText:=str;
    new(ptr);
    ptr^.ID:=strtoint(datas[0]);
    ptr^.msg:=stringReplace(datas[1],'<br/>',#13#10,[rfReplaceAll,rfIgnoreCase]);
    ptr^.msg:=stringReplace(ptr^.msg,'<br>',#13#10,[rfReplaceAll,rfIgnoreCase]);
    ptr^.Image:=datas[2];
    ptr^.music:=datas[17];
    ptr^.next:=strtoint(datas[3]);
    ptr^.eval:=datas[4];
    ptr^.select1Msg:=datas[5];
    ptr^.select1cond:=datas[6];
    ptr^.select1to:=strtoint(datas[7]);
    ptr^.select2Msg:=datas[8];
    ptr^.select2cond:=datas[9];
    ptr^.select2to:=strtoint(datas[10]);
    ptr^.select3Msg:=datas[11];
    ptr^.select3cond:=datas[12];
    ptr^.select3to:=strtoint(datas[13]);
    ptr^.select4Msg:=datas[14];
    ptr^.select4cond:=datas[15];
    ptr^.select4to:=strtoint(datas[16]);
    scenes.Add(ptr);
    datas.Free;
  end
  else
  if pos('var',str)=0 then
  begin
  eval(str);
  end;


end;

procedure TForm2.setText(msg: tlabel; text: string);
var
i,j:integer;
flag:boolean;
text2:widestring;
begin
if (text='') then begin
msgstring:='';
exit;

end;

if ((currentPOS<>0) and (currentPOS<>-1))  then exit;
msg.Caption:='';
text2:=text;
currentPOS:=0;
msgstring:='';
flag:=true;
i:=0;
j:=0;

while (flag)  do
begin
  i:=i+1;
  j:=j+1;
  msgstring:=msgstring+text2[i];
  if text2[i]=#13 then j:=1;

  if (i>=length(text2)) then flag:=false;
  if (j mod 28)=0 then
  begin
  j:=1;
  msgstring:=msgstring+#13#10;
  end;



end;
end;

function TForm2.getID(ID:integer):integer;
var
flag:boolean;
i:integer;
begin
i:=-1;
flag:=false;
while not(flag) do
  begin
    inc(i);
    if pscene(scenes[i])^.ID=ID then begin
                                     result:= i;
                                     flag:=true;
                                     exit;
                                     end;
    if(i>=scenes.Count-1)then
    begin
    showmessage('`̃V[ł::No'+inttostr(ID));
    result:= 0;
    flag:=true;
    exit;
    end;



  end;

end;

function TForm2.logic(expr: string): boolean;
begin
expr:=rep(expr);
result:=false;

if ((FEvaluator as tevaluator).Evaluate(expr))=1 then result:=true;

end;


procedure TForm2.Select1Click(Sender: TObject);
begin
show(pscene(scenes[current])^.select1To);
end;

procedure TForm2.Select2Click(Sender: TObject);
begin
show(pscene(scenes[current])^.select2To);
end;

procedure TForm2.Select3Click(Sender: TObject);
begin
show(pscene(scenes[current])^.select3To);
end;

procedure TForm2.Select4Click(Sender: TObject);
begin
show(pscene(scenes[current])^.select4To);
end;

procedure TForm2.show(ID: integer);
var
rcd:integer;
typ:string;

begin
if ((currentPOS<>0) and (currentPOS<>-1)) then exit;
rcd:=getID(ID);
current:=rcd;
select1.Visible:=false;
select2.Visible:=false;
select3.Visible:=false;
select4.Visible:=false;

eval(pscene(scenes[rcd])^.eval);

if pscene(scenes[rcd])^.select1to<>0 then
  begin
    if (pscene(scenes[rcd])^.select1cond='') then pscene(scenes[rcd])^.select1cond:='true';
  if (logic(pscene(scenes[rcd])^.select1cond))  then
  begin
  select1.Caption:=pscene(scenes[rcd])^.select1Msg;
  select1.Visible:=true;
  end;
  end;

if pscene(scenes[rcd])^.select2to<>0 then
  begin
    if (pscene(scenes[rcd])^.select2cond='') then pscene(scenes[rcd])^.select2cond:='true';
  if (logic(pscene(scenes[rcd])^.select2cond))  then
  begin
  select2.Caption:=pscene(scenes[rcd])^.select2Msg;
  select2.Visible:=true;
  end;
  end;

if pscene(scenes[rcd])^.select3to<>0 then
  begin
    if (pscene(scenes[rcd])^.select3cond='') then pscene(scenes[rcd])^.select3cond:='true';
  if (logic(pscene(scenes[rcd])^.select3cond))  then
  begin
  select3.Caption:=pscene(scenes[rcd])^.select3Msg;
  select3.Visible:=true;
  end;
  end;

if pscene(scenes[rcd])^.select4to<>0 then
  begin
    if (pscene(scenes[rcd])^.select4cond='') then pscene(scenes[rcd])^.select4cond:='true';
  if (logic(pscene(scenes[rcd])^.select4cond)) then
  begin
  select4.Caption:=pscene(scenes[rcd])^.select4Msg;
  select4.Visible:=true;
  end;
  end;

if ((not select1.Visible) and (not select2.Visible) and (not select3.Visible) and (not select4.Visible)
   and(pscene(scenes[rcd])^.next=0)) then
   begin
     select1.Caption:='ŏȂ';
     pscene(scenes[rcd])^.select1to:=0;
     select1.Visible:=true;
   end;


if pscene(scenes[rcd])^.image<>'' then
  begin
    hasGraphic:=true;
    image.picture.LoadFromFile(getcurrentdir+'\'+pscene(scenes[rcd])^.image);
    image.Visible:=true;
  end;

if pscene(scenes[rcd])^.music<>'' then
  begin
   if (lowercase(extractfileext(pscene(scenes[rcd])^.music))='.mid') then typ:='sequencer';
   if (lowercase(extractfileext(pscene(scenes[rcd])^.music))='.mp3') then typ:='MPEGVideo';
   if (lowercase(extractfileext(pscene(scenes[rcd])^.music))='.wav') then typ:='waveaudio';

  mciSendString(pchar('stop audio'),nil,0,F_hHandle);
  mciSendString(pchar('close audio'),nil,0,F_hHandle);
  mciSendString(pchar('open "'+getcurrentdir+'\'+pscene(scenes[rcd])^.music+'" type '+typ+' alias audio'),nil,0,F_hHandle);
  mciSendString(pchar('play audio notify'),nil,0,F_hHandle);
  end;

  setText(msg,pscene(scenes[rcd])^.Msg);
end;

procedure TForm2.Timer1Timer(Sender: TObject);

begin
if currentPOS=-1 then exit;
inc(currentPOS);
if currentPOS>msgstring.Length then
begin
  currentPOS:=-1;
  exit;
end;
msg.Caption:=copy(msgstring,0,currentPOS);
end;

end.
