unit adventure;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, FileUtil,
  Controls, Forms, Dialogs, ExtCtrls, StdCtrls, fpexprpars, mmsystem;

type

  { TForm2 }

  TForm2 = class(TForm)
    GroupBox1: TGroupBox;
    Select1: TButton;
    Select2: TButton;
    Select3: TButton;
    Select4: TButton;
    msg: TLabel;
    Image: TImage;
    Timer1: TTimer;
    OpenDialog: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure Select1Click(Sender: TObject);
    procedure Select2Click(Sender: TObject);
    procedure Select3Click(Sender: TObject);
    procedure Select4Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
  private
    { Private é¾ }
  public
    procedure setScene(script: string);
    procedure Show(ID: integer);
    function getID(ID: integer): integer;
    procedure setText(msg: tlabel; Text: string);
    function eval(exp: string): boolean;
    function rep(s: string): string;
    function logic(expr: string): boolean;



  end;

type
  scene = record
    ID: integer;
    Msg: string;
    Image: string;
    Music: string;
    Next: integer;
    eval: string;
    select1Msg: string;
    select1cond: string;
    select1to: integer;
    select2Msg: string;
    select2cond: string;
    select2to: integer;
    select3Msg: string;
    select3cond: string;
    select3to: integer;
    select4Msg: string;
    select4cond: string;
    select4to: integer;
  end;
  pScene = ^scene;

type
  flg = record
    Name: string;
    Value: extended;
  end;
  pflg = ^flg;

var
  Form2: TForm2;
  senario: TStringList;
  scenes: TList;
  flgs: TList;
  FParser: TFPExpressionParser;

  hasGraphic: boolean;
  current: integer;
  currentPOS: integer;
  msgstring: string;
  port: string;
  F_hHandle: hwnd;
  PrevWndProc: WNDPROC;
//FEvaluator: TEasyEvaluator;
   {
     VK_LBUTTON = 1;
     VK_RBUTTON = 2;
     VK_CANCEL = 3;
     VK_MBUTTON = 4;
     VK_BACK = 8;
     VK_TAB = 9;
     VK_CLEAR = 12;
     VK_RETURN = 13;
     VK_SHIFT = 16;
     VK_CONTROL = 17;
     VK_MENU = 18;
     VK_PAUSE = 19;
     VK_CAPITAL = 20;
     VK_ESCAPE = 27;
     VK_SPACE = 32;
     VK_PRIOR = 33;
     VK_NEXT = 34;
     VK_END = 35;
     VK_HOME = 36;
     VK_LEFT = 37;
     VK_UP = 38;
     VK_RIGHT = 39;
     VK_DOWN = 40;
     VK_SELECT = 41;
     VK_PRINT = 42;
     VK_EXECUTE = 43;
     VK_SNAPSHOT = 44;
     VK_INSERT = 45;
     VK_DELETE = 46;
     VK_HELP = 47;
     VK_0 = 48;
     VK_1 = 49;
     VK_2 = 50;
     VK_3 = 51;
     VK_4 = 52;
     VK_5 = 53;
     VK_6 = 54;
     VK_7 = 55;
     VK_8 = 56;
     VK_9 = 57;
     VK_A = 65;
     VK_B = 66;
     VK_C = 67;
     VK_D = 68;
     VK_E = 69;
     VK_F = 70;
     VK_G = 71;
     VK_H = 72;
     VK_I = 73;
     VK_J = 74;
     VK_K = 75;
     VK_L = 76;
     VK_M = 77;
     VK_N = 78;
     VK_O = 79;
     VK_P = 80;
     VK_Q = 81;
     VK_R = 82;
     VK_S = 83;
     VK_T = 84;
     VK_U = 85;
     VK_V = 86;
     VK_W = 87;
     VK_X = 88;
     VK_Y = 89;
     VK_Z = 90;
     VK_LWIN = 91;
     VK_RWIN = 92;
     VK_APPS = 93;
     VK_NUMPAD0 = 96;
     VK_NUMPAD1 = 97;
     VK_NUMPAD2 = 98;
     VK_NUMPAD3 = 99;
     VK_NUMPAD4 = 100;
     VK_NUMPAD5 = 101;
     VK_NUMPAD6 = 102;
     VK_NUMPAD7 = 103;
     VK_NUMPAD8 = 104;
     VK_NUMPAD9 = 105;
     VK_MULTIPLY = 106;
     VK_ADD = 107;
     VK_SEPARATOR = 108;
     VK_SUBTRACT = 109;
     VK_DECIMAL = 110;
     VK_DIVIDE = 111;
     VK_F1 = 112;
     VK_F2 = 113;
     VK_F3 = 114;
     VK_F4 = 115;
     VK_F5 = 116;
     VK_F6 = 117;
     VK_F7 = 118;
     VK_F8 = 119;
     VK_F9 = 120;
     VK_F10 = 121;
     VK_F11 = 122;
     VK_F12 = 123;
     VK_F13 = 124;
     VK_F14 = 125;
     VK_F15 = 126;
     VK_F16 = 127;
     VK_F17 = 128;
     VK_F18 = 129;
     VK_F19 = 130;
     VK_F20 = 131;
     VK_F21 = 132;
     VK_F22 = 133;
     VK_F23 = 134;
     VK_F24 = 135;
     }
implementation

{$R *.lfm}

function WndCallback(Ahwnd: HWND; uMsg: UINT; wParam: WParam; lParam: LParam):LRESULT; stdcall;
begin
if (uMsg = MM_MCINOTIFY) then
begin
if wParam = MCI_NOTIFY_SUCCESSFUL then
begin
// Rewind the music
mciSendString('seek audio to start', nil, 0, Form2.Handle);
// Replay music
mciSendString(PChar('play audio notify'), nil, 0, Form2.Handle);
end;
end;
result:=CallWindowProc(PrevWndProc,Ahwnd, uMsg, WParam, LParam);
end;


function TForm2.eval(exp: string): boolean;
var

  i,k: integer;
  flag, isset: boolean;
  l,key, Value: string;
  pflgs: pflg;
begin
  if exp = '' then
    exit;
  isset := False;
  exp := rep(exp);
  if pos(':=', exp) <> 0 then
  begin
    key := Trim((copy(exp, 0, pos(':=', exp) - 1)));
    Value := copy(exp, pos(':=', exp) + 2, length(exp));
    flag := True;
    i := 0;
    if flgs.Count <> 0 then
      while (flag) do
      begin
        if (pflg(flgs[i])^.Name = key) then
        begin
          flag := False;
          Fparser.IdentifierByName(key).Value := Value;
          pflg(flgs[i])^.Value := StrToInt(Value);
          isset := True;
//        showmessage(key+'>'+value);
        end;
        Inc(i);
        if (i > flgs.Count - 1) then
          flag := False;

      end;
    if isset = False then
    begin
      new(pflgs);
      pflgs^.Name := key;
      pflgs^.Value := StrToInt(Value);
      flgs.Add(pflgs);
      FParser.Identifiers.AddintegerVariable(key, StrToInt(Value));
 //       showmessage(key+'('+inttostr(length(key))+')->>'+value);
 //       l:='';
 //       for k:=1 to 12 do
 //       begin
 //          l:=l+inttohex(ord(key[k]),2)+':';
 //       end;
 //       showmessage(l);
    end;
  end;

end;

function TForm2.rep(s: string): string;
begin
  s := stringReplace(s, chr($ef)+chr($bb)+chr($bf), '', [rfReplaceAll, rfIgnoreCase]);
  s := stringReplace(s, '==', '[eq]', [rfReplaceAll, rfIgnoreCase]);
  s := stringReplace(s, '!=', '<>', [rfReplaceAll, rfIgnoreCase]);
  s := stringReplace(s, '=', ':=', [rfReplaceAll, rfIgnoreCase]);
  s := stringReplace(s, '[eq]', '=', [rfReplaceAll, rfIgnoreCase]);
  s := stringReplace(s, 'true', '1', [rfReplaceAll, rfIgnoreCase]);
  s := stringReplace(s, 'false', '0', [rfReplaceAll, rfIgnoreCase]);
  s := stringReplace(s, '&&', 'and', [rfReplaceAll, rfIgnoreCase]);
  s := stringReplace(s, '||', 'or', [rfReplaceAll, rfIgnoreCase]);
  s := stringReplace(s, ';', '', [rfReplaceAll, rfIgnoreCase]);
  s := stringReplace(s, 'var ', '', [rfReplaceAll, rfIgnoreCase]);
  Result := s;
end;

procedure TForm2.FormClick(Sender: TObject);
begin
  if (pscene(scenes[current])^.Next) <> 0 then
  begin
    Show(pscene(scenes[current])^.Next);
  end;
end;

procedure TForm2.FormCreate(Sender: TObject);
var
  i: integer;
  console: TStringList;

begin
      form2.Left := 0;
      form2.Top := 0;
      form2.Width := Screen.Width;
      form2.Height := Screen.Height;
      groupbox1.Left := round(Screen.Width * 0.7);
      groupbox1.top := 1;
      groupbox1.Width := round(Screen.Width * 0.3);
      groupbox1.Height := round(Screen.Height * 0.6);
      image.Left := 0;
      image.Top := 0;
      image.Width := round(Screen.Width * 0.7);
      image.Height := round(Screen.Height * 0.6);
      msg.top := round(Screen.Height * 0.61);
      msg.Left := 0;
      msg.Width := Screen.Width;
      msg.Font.Height := 37;
      select1.Font.Height := 25;
      select1.Width := round(Screen.Width * 0.28);
      select1.Height := 50;
      select2.Font.Height := 25;
      select2.Width := round(Screen.Width * 0.28);
      select2.Height := 50;
      select3.Font.Height := 25;
      select3.Width := round(Screen.Width * 0.28);
      select3.Height := 50;
      select4.Font.Height := 25;
      select4.Width := round(Screen.Width * 0.28);
      select4.Height := 50;
      select1.Top := 40;
      select2.Top := 120;
      select3.Top := 200;
      select4.Top := 280;
      //form2.Position:=poDefault;

      form2.BorderStyle := bsNone;
      form2.FormStyle := fsStayOnTop;


  F_hHandle := form2.Handle;
  PrevWndProc:=Windows.WNDPROC(SetWindowLong(Self.Handle,GWL_WNDPROC,PtrInt(@WndCallback)));
  FParser := TFpExpressionParser.Create(self);
  currentPOS := -1;
  scenes := TList.Create;
  flgs := TList.Create;
  senario := TStringList.Create;


  if fileexists(getcurrentdir + '/' + 'senario.js') then
    senario.LoadFromFile(getcurrentdir + '/' + 'senario.js')
  else
  begin
    if opendialog.Execute then
    begin
      senario.LoadFromFile(opendialog.FileName);
      setcurrentdir(extractfilepath(opendialog.filename));
    end
    else
      application.Terminate;
  end;
  for I := 0 to senario.Count -1 do
  begin
    setScene(senario[i]);
  end;

  Show(0);
end;

procedure TForm2.FormDestroy(Sender: TObject);
var
  i: integer;
  console: TStringList;
  pid: string;
begin
  Fparser.Free;
  senario.Free;
  for i := 0 to scenes.Count - 1 do
    dispose(Pscene(scenes[i]));
  scenes.Free;
  for i := 0 to flgs.Count - 1 do
    dispose(Pflg(flgs[i]));
  flgs.Free;

  mciSendString(PChar('stop audio'), nil, 0, F_hHandle);
  mciSendString(PChar('close audio'), nil, 0, F_hHandle);
end;

procedure TForm2.FormKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
begin
  if key = 32 then
    form2.Click;

  if key = 27 then
  begin
    application.Terminate;
    key := 0;
  end;
  if (ssalt in shift) and (key = 13) then
  begin
    if form2.BorderStyle = bsNone then
    begin
      form2.BorderStyle := bsDialog;
      form2.Left := 100;
      form2.Top := 100;
      form2.Width := 740;
      form2.Height := 450;
      groupbox1.Left := 527;
      groupbox1.top := 16;
      groupbox1.Width := 193;
      groupbox1.Height := 209;
      image.Left := 0;
      image.Top := 0;
      image.Width := 521;
      image.Height := 233;
      msg.top := 231;
      msg.Left := 0;
      msg.Width := 598;
      msg.Font.Height := 25;
      select1.Font.Height := 15;
      select1.Width := 187;
      select1.Height := 25;
      select2.Font.Height := 15;
      select2.Width := 187;
      select2.Height := 25;
      select3.Font.Height := 15;
      select3.Width := 187;
      select3.Height := 25;
      select4.Font.Height := 15;
      select4.Width := 187;
      select4.Height := 25;
      select1.Top := 40;
      select2.Top := 80;
      select3.Top := 120;
      select4.Top := 160;
      form2.Position := poDesktopCenter;

      form2.FormStyle := fsNormal;
    end
    else
    begin
      form2.Left := 0;
      form2.Top := 0;
      form2.Width := Screen.Width;
      form2.Height := Screen.Height;
      groupbox1.Left := round(Screen.Width * 0.7);
      groupbox1.top := 1;
      groupbox1.Width := round(Screen.Width * 0.3);
      groupbox1.Height := round(Screen.Height * 0.6);
      image.Left := 0;
      image.Top := 0;
      image.Width := round(Screen.Width * 0.7);
      image.Height := round(Screen.Height * 0.6);
      msg.top := round(Screen.Height * 0.61);
      msg.Left := 0;
      msg.Width := Screen.Width;
      msg.Font.Height := 37;
      select1.Font.Height := 25;
      select1.Width := round(Screen.Width * 0.28);
      select1.Height := 50;
      select2.Font.Height := 25;
      select2.Width := round(Screen.Width * 0.28);
      select2.Height := 50;
      select3.Font.Height := 25;
      select3.Width := round(Screen.Width * 0.28);
      select3.Height := 50;
      select4.Font.Height := 25;
      select4.Width := round(Screen.Width * 0.28);
      select4.Height := 50;
      select1.Top := 40;
      select2.Top := 120;
      select3.Top := 200;
      select4.Top := 280;
      //form2.Position:=poDefault;

      form2.BorderStyle := bsNone;
      form2.FormStyle := fsStayOnTop;

    end;
  end;
end;


procedure TForm2.setScene(script: string);
var
  datas: TStringList;
  str: string;
  i: integer;
  ptr: pscene;
begin
  if pos('//', script) <> 0 then
  begin
    script := copy(script, 0, pos('//', script) - 1);
  end;
  if script = '' then
    exit;

  str := script;
  if Copy(str, 0, 9) = 'setScene(' then
  begin
    i := 0;
    str := copy(str, 10, length(str) - 9);
    if pos(');', str) <> 0 then
      str := copy(str, 0, pos(');', str) - 1);
    datas := TStringList.Create;
    datas.CommaText := str;
    new(ptr);
    ptr^.ID := StrToInt(datas[0]);
    ptr^.msg := systoutf8(stringReplace(utf8tosys(datas[1]), '<br/>',
      #13#10, [rfReplaceAll, rfIgnoreCase]));
    ptr^.msg := systoutf8(stringReplace(utf8tosys(ptr^.msg), '<br>',
      #13#10, [rfReplaceAll, rfIgnoreCase]));
    ptr^.Image := datas[2];
    ptr^.music := datas[17];
    ptr^.Next := StrToInt(datas[3]);
    ptr^.eval := datas[4];
    ptr^.select1Msg := datas[5];
    ptr^.select1cond := datas[6];
    ptr^.select1to := StrToInt(datas[7]);
    ptr^.select2Msg := datas[8];
    ptr^.select2cond := datas[9];
    ptr^.select2to := StrToInt(datas[10]);
    ptr^.select3Msg := datas[11];
    ptr^.select3cond := datas[12];
    ptr^.select3to := StrToInt(datas[13]);
    ptr^.select4Msg := datas[14];
    ptr^.select4cond := datas[15];
    ptr^.select4to := StrToInt(datas[16]);
    scenes.Add(ptr);
    datas.Free;
  end
  else
  if pos('var', str) = 0 then
  begin
    eval(trim(str));
   // showmessage(str);
  end;

end;

procedure TForm2.setText(msg: tlabel; Text: string);
var
  i, j: integer;
  flag: boolean;
  text2: string;
  rep: boolean;
begin
if text='' then begin
msgstring:='';
exit;

end;

  if ((currentPOS <> 0) and (currentPOS <> -1)) then
    exit;
  msg.Caption := '';
  text2 := (Text);
  currentPOS := 0;
  msgstring := '';
  flag := True;
  rep := False;
  i := 0;
  j := 0;
  while (flag) do
  begin

    i := i + 1;
    j := j + 1;
    if (rep = True) and (text2[i] > #191) then
    begin
      rep := False;
      j := 1;
      msgstring := msgstring + #13#10;
    end;
    msgstring := msgstring + text2[i];
    if text2[i] = #13 then
      j := 1;

    if (i >= length(text2)) then
      flag := False;
    if (j mod 80) = 0 then
      rep := True;

  end;
end;

function TForm2.getID(ID: integer): integer;
var
  flag: boolean;
  i: integer;
begin
  i := -1;
  flag := False;
  while not (flag) do
  begin
    Inc(i);
    if pscene(scenes[i])^.ID = ID then
    begin
      Result := i;
      flag := True;
      exit;
    end;
    if (i >= scenes.Count-1) then
    begin
      showmessage('未定義のシーンです'+inttostr(ID));
      Result := 0;
      flag := True;
      exit;
    end;

  end;

end;

function TForm2.logic(expr: string): boolean;
var
  res: TFPExpressionResult;
begin
  //showmessage(expr);
  expr := rep(expr);
  //showmessage(expr);
  Result := True;
  //if expr='' then expr:='true';
  fparser.expression := expr;
  res := FParser.Evaluate;
  Result := res.resboolean;

end;




procedure TForm2.Select1Click(Sender: TObject);
begin
  Show(pscene(scenes[current])^.select1To);
end;

procedure TForm2.Select2Click(Sender: TObject);
begin
  Show(pscene(scenes[current])^.select2To);
end;

procedure TForm2.Select3Click(Sender: TObject);
begin
  Show(pscene(scenes[current])^.select3To);
end;

procedure TForm2.Select4Click(Sender: TObject);
begin
  Show(pscene(scenes[current])^.select4To);
end;

procedure TForm2.Show(ID: integer);
var
  rcd: integer;
  typ: string;
  console: TStringList;
  pid: string;
begin
  if ((currentPOS <> 0) and (currentPOS <> -1)) then
    exit;
  rcd := getID(ID);
  current := rcd;
  select1.Visible := False;
  select2.Visible := False;
  select3.Visible := False;
  select4.Visible := False;

  eval(pscene(scenes[rcd])^.eval);

  if pscene(scenes[rcd])^.select1to <> 0 then
  begin
    if (pscene(scenes[rcd])^.select1cond = '') then
      pscene(scenes[rcd])^.select1cond := 'true';
    if (logic(pscene(scenes[rcd])^.select1cond)) then
    begin
      select1.Caption := pscene(scenes[rcd])^.select1Msg;
      select1.Visible := True;
    end;
  end;

  if pscene(scenes[rcd])^.select2to <> 0 then
  begin
    if (pscene(scenes[rcd])^.select2cond = '') then
      pscene(scenes[rcd])^.select2cond := 'true';
    if (logic(pscene(scenes[rcd])^.select2cond)) then
    begin
      select2.Caption := pscene(scenes[rcd])^.select2Msg;
      select2.Visible := True;
    end;
  end;

  if pscene(scenes[rcd])^.select3to <> 0 then
  begin
    if (pscene(scenes[rcd])^.select3cond = '') then
      pscene(scenes[rcd])^.select3cond := 'true';
    if (logic(pscene(scenes[rcd])^.select3cond)) then
    begin
      select3.Caption := pscene(scenes[rcd])^.select3Msg;
      select3.Visible := True;
    end;
  end;

  if pscene(scenes[rcd])^.select4to <> 0 then
  begin
    if (pscene(scenes[rcd])^.select4cond = '') then
      pscene(scenes[rcd])^.select4cond := 'true';
    if (logic(pscene(scenes[rcd])^.select4cond)) then
    begin
      select4.Caption := pscene(scenes[rcd])^.select4Msg;
      select4.Visible := True;
    end;
  end;

  if ((not select1.Visible) and (not select2.Visible) and (not select3.Visible) and
    (not select4.Visible) and (pscene(scenes[rcd])^.Next = 0)) then
  begin
    select1.Caption := 'はじめに戻る';
    pscene(scenes[rcd])^.select1to := 0;
    select1.Visible := True;
  end;


  if (pscene(scenes[rcd])^.image <> '' ) and (fileexists(utf8tosys(getcurrentdir + '/' + pscene(scenes[rcd])^.image))) then
  begin
    hasGraphic := True;
    image.picture.LoadFromFile(utf8tosys(getcurrentdir + '/' + pscene(scenes[rcd])^.image));
    image.Visible := True;
  end;

  if pscene(scenes[rcd])^.music <> '' then
  begin
    if (lowercase(extractfileext(pscene(scenes[rcd])^.music)) = '.mid') then
      typ := 'sequencer';
    if (lowercase(extractfileext(pscene(scenes[rcd])^.music)) = '.mp3') then
      typ := 'MPEGVideo';
    if (lowercase(extractfileext(pscene(scenes[rcd])^.music)) = '.wav') then
      typ := 'waveaudio';

    if fileexists(utf8tosys(getcurrentdir + '/' + pscene(scenes[rcd])^.music))  then
    begin

    mciSendString(PChar('stop audio'), nil, 0, F_hHandle);
    mciSendString(PChar('close audio'), nil, 0, F_hHandle);
    mciSendString(PChar('open "' + utf8tosys(getcurrentdir + '/' + pscene(scenes[rcd])^.music) +
      '" type ' + typ + ' alias audio'), nil, 0, F_hHandle);
    mciSendString(PChar('play audio notify'), nil, 0, F_hHandle);

    end;

  end;

  setText(msg, pscene(scenes[rcd])^.Msg);
end;

procedure TForm2.Timer1Timer(Sender: TObject);

var
  flag: boolean;
begin
  flag := False;
  if currentPOS = -1 then
    exit;
  while not flag do
  begin

    Inc(currentPOS);

    msg.Caption := copy(msgstring, 0, currentPOS);
    if msgstring[currentPOS + 1] > #191 then
      flag := True;
    if currentPOS >= length(msgstring) then
      flag := True;
  end;


  if (currentPOS) >= Length(msgstring) then
  begin
    msg.Caption := msgstring;
    currentPOS := -1;
    exit;
  end;
end;

end.
